"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inlineCompositeEncoding = inlineCompositeEncoding;
exports.boolListLayout = boolListLayout;
exports.subwordListLayout = subwordListLayout;
exports.inlineCompositeListLayout = inlineCompositeListLayout;

var _readData = require("@capnp-js/read-data");

var _layout = require("@capnp-js/layout");

function inlineCompositeEncoding(p) {
  return {
    flag: 0x07,
    bytes: (0, _layout.structBytes)((0, _readData.int32)(p.object.segment.raw, p.object.position + 4))
  };
}

function boolListLayout(p) {
  return {
    tag: "bool list",
    begin: p.object.position,
    length: p.hi >>> 3
  };
}

function subwordListLayout(p, flag) {
  return {
    tag: "non-bool list",
    encoding: _layout.listEncodings[flag],
    begin: p.object.position,
    length: p.hi >>> 3
  };
}

function inlineCompositeListLayout(p, bytes) {
  return {
    tag: "non-bool list",
    encoding: {
      flag: 0x07,
      bytes
    },
    begin: p.object.position + 8,
    length: (0, _readData.int32)(p.object.segment.raw, p.object.position) >>> 2
  };
}